% 7.1 PI controller for arm robot

s=tf('s');
% Plant
alpha=10; beta=50; P=beta/(s+alpha)
% Time-domain specifications
Tr=0.15; %[sec]
zeta1=0.7;
Ts=0.5; %[sec]

% Area for pole assignment
Omega1=1.8/Tr;
t1=pi/2:0.01:3*pi/2;
x1=Omega1*cos(t1); y1=Omega1*sin(t1);

K1=sqrt(1-zeta1^2)/zeta1;
t2=-12:0.1:0; yK1=K1*t2; yK2=-K1*t2;

sigma=4.6/Ts; ts=-12:0.1:12; ys=-sigma*ones(length(ts));
figure(1); hold on;
plot(x1,y1); plot(t2,yK1,t2,yK2); plot(ys,ts); sgrid;
title('Aera for pole placement')

% C(s)=Kp(1+1/(Tis))
% Pole assignment
p_FB=[-20+10*j -20-10*j];
plot(real(p_FB(1)), imag(p_FB(1)),'rx',real(p_FB(2)), imag(p_FB(2)),'rx');

phai=conv([1 -p_FB(1)],[1 -p_FB(2)]);
Kp=(phai(2)-alpha)/beta; Ti=Kp*beta/phai(3);
C=Kp*(1+1/(Ti*s))

L=C*P; figure(2); margin(L); [gm,PM,wcg,wcp]=margin(L)

G=L/(1+L); Gu=C/(1+L); Gr=minreal(G); figure(3); pzmap(Gr) 

t=0:0.001:1;
figure(4); hold on;
step(Gr,t); step(Gu,t); grid;
title('Step response (Gyr & Gur)')
stepinfo(Gr)