% Advanced level
% Problem 10.2

% Plant
s=tf('s');
P=50/(s*(s+10)), ssP=ss(P);
ap=ssP.a; bp=ssP.b; cp1=ssP.c;

% Internal model
MR=1/s, ssMR=ss(MR);
na=length(ap); nar=length(ssMR.a);
AR=ssMR.a; BR=ssMR.b;

%A_bar, B_bar, C_bar
A=[AR -BR*cp1; zeros(na, nar) ap],
B=[zeros(nar,1); bp], Bi=[BR; zeros(na,1)],
C=[zeros(1, nar) cp1],

% 2-A
% Optimal state feedback (Refer to text p149)
% case 1
R1=1, Q1=diag([1 1 1]), F1=lqr(A,B,Q1,R1)
FR1=F1(1,1); Fp1=F1(1,2:na+1);
pole_feedsys1=eig(A-B*F1)
FS1=ss(A-B*F1,Bi,C,0); FS1u=ss(A-B*F1,Bi,-F1,0);
% case 2
R2=1, Q2=diag([1000 1 1]), F2=lqr(A,B,Q2,R2)
FR2=F2(1,1); Fp2=F2(1,2:na+1);
pole_feedsys2=eig(A-B*F2)
FS2=ss(A-B*F2,Bi,C,0); FS2u=ss(A-B*F2,Bi,-F2,0);
% case 3
R3=1000, Q3=diag([1000 1 1]), F3=lqr(A,B,Q3,R3)
FR3=F3(1,1); Fp3=F3(1,2:na+1);
pole_feedsys3=eig(A-B*F3)
FS3=ss(A-B*F3,Bi,C,0); FS3u=ss(A-B*F3,Bi,-F3,0);

% Internal model + tate feedback (Plot step responses for different weightings) 
t=0:0.01:4;
figure(1)
subplot(2,1,1); hold on;
step(FS1,t); step(FS2,t); step(FS3,t); grid;
subplot(2,1,2); hold on;
step(FS1u,t); step(FS2u,t); step(FS3u,t); grid;

% 2-B
% Observer gain (Case 2 is selected.)
p05=0.5*[pole_feedsys2(1) pole_feedsys2(2)], L05=place(ap',cp1',p05)', eig(ap-L05*cp1)
p1=1*[pole_feedsys2(1) pole_feedsys2(2)], L1=place(ap',cp1',p1)', eig(ap-L1*cp1)
p2=2*[pole_feedsys2(1) pole_feedsys2(2)], L2=place(ap',cp1',p2)', eig(ap-L2*cp1)
p5=5*[pole_feedsys2(1) pole_feedsys2(2)], L5=place(ap',cp1',p5)', eig(ap-L5*cp1)
p10=10*[pole_feedsys2(1) pole_feedsys2(2)], L10=place(ap',cp1',p10)', eig(ap-L10*cp1)

%A_tilde, B_tilde, C_tilde by Observer gain
At05=[AR -BR*cp1 zeros(1,na); zeros(na,1) ap zeros(na,na); zeros(na,1) L05*cp1 ap-L05*cp1];
At1=[AR -BR*cp1 zeros(1,na); zeros(na,1) ap zeros(na,na); zeros(na,1) L1*cp1 ap-L1*cp1];
At2=[AR -BR*cp1 zeros(1,na); zeros(na,1) ap zeros(na,na); zeros(na,1) L2*cp1 ap-L2*cp1];
At5=[AR -BR*cp1 zeros(1,na); zeros(na,1) ap zeros(na,na); zeros(na,1) L5*cp1 ap-L5*cp1];
At10=[AR -BR*cp1 zeros(1,na); zeros(na,1) ap zeros(na,na); zeros(na,1) L10*cp1 ap-L10*cp1];

Bt=[0; bp; bp]; Bit=[BR; zeros(2*na,1)];
Ct=[0 cp1 zeros(1,na)];
Ft=[FR2 zeros(1,na), Fp2];

% Internal model + state observer + state feedback
sysob05=ss(At05-(Bt*Ft),Bit,Ct,0); sysobu05=ss(At05-Bt*Ft,Bit,-Ft,0);
sysob1=ss(At1-Bt*Ft,Bit,Ct,0); sysobu1=ss(At1-Bt*Ft,Bit,-Ft,0);
sysob2=ss(At2-Bt*Ft,Bit,Ct,0); sysobu2=ss(At2-Bt*Ft,Bit,-Ft,0);
sysob5=ss(At5-Bt*Ft,Bit,Ct,0); sysobu5=ss(At5-Bt*Ft,Bit,-Ft,0);
sysob10=ss(At10-Bt*Ft,Bit,Ct,0); sysobu10=ss(At10-Bt*Ft,Bit,-Ft,0);

% simulations
figure(2), 
subplot(2,1,1); hold on;
step(sysob05); step(sysob1); step(sysob2); step(sysob5); step(sysob10); grid;
subplot(2,1,2); hold on;
step(sysobu05); step(sysobu1); step(sysobu2); step(sysobu5); step(sysobu10); grid;