% Basic Level
% Problem 10.5

% Plant
Ap=[0 1; -7 -9], Bp=[0; 1], Cp=[4 0]
na=length(Ap)

%Internal model
AR=0, BR=1,

% A_bar, B_bar, C_bar
Ag=[AR -BR*Cp; zeros(na,1) Ap]
Bg=[0; Bp]; Bi=[BR; zeros(na,1)];
Cg=[0 Cp];

% Time-domain specifications
Tr=0.1;, Mp=0.1;, Ts=0.5;
zeta=-2.412*Mp^3+3.853*Mp^2-2.518*Mp+0.820 
sigma=6/Ts

% Area for pole assignment
Omega=1.8/Tr;
t1=pi/2:0.01:3*pi/2;
x1=Omega*cos(t1); y1=Omega*sin(t1);

K1=sqrt(1-zeta^2)/zeta
t2=-100:0.1:0; yK1=K1*t2; yK2=-K1*t2;

ts=-100:0.1:100; ys=-sigma*ones(length(ts));
figure(1); hold on;
plot(x1,y1); plot(t2,yK1,t2,yK2); 
plot(ys,ts); sgrid;
title('Area for pole placement')

% Pole assignment
p=[-20+10*j -20-10*j -100]
plot(real(p(1)), imag(p(1)),'rx',real(p(2)), imag(p(2)),'rx',real(p(3)), imag(p(3)),'rx');

F=place(Ag,Bg,p)
FR=F(:,1)
FP=F(:,2:3)

%iInternal model + state feedback
sys=ss(Ag-Bg*F,Bi,Cg,0); sysu=ss(Ag-Bg*F,Bi,-F,0);
figure(2), hold on;
step(sys); grid;
figure(3), hold on;
step(sysu); grid;

