% 10.1 PID controller for arm robot
 
% Plant
s=tf('s');
alpha=10; beta=50; P=beta/(s*(s+alpha))

% Pole assignment and PID parameters
p_FB=[-20+10*j -20-10*j -50];
phai=conv(conv([1 -p_FB(1)],[1 -p_FB(2)]), [1 -p_FB(3)]);
Td=(phai(2)-alpha)/phai(3)
Kp=phai(3)/beta
Ti=phai(3)/phai(4)

C=Kp*(1+1/(Ti*s)+Td*s/(0.1*Td*s+1))
L=C*P,
G_PID=L/(1+L); G_PIDr=minreal(G_PID)
G_PIDu=C/(1+L); G_PIDur=minreal(G_PIDu)

t=0:0.001:1;
subplot(2,1,1);
step(G_PIDr,t);
title('Output of step response')
subplot(2,1,2);
step(G_PIDu,t);
title('Control input of step response')

z = zero(G_PIDr), p = pole(G_PIDr)
