% 10.4 Servo system
 
% Plant
ap=[0 0 1 0; 0 0 0 1; 0 -2 -6 0.002; 0 40 6 -0.04];
bp=[0; 0; 16; -15]; cp1=[1 0 0 0];

na=length(ap);
Co=ctrb(ap,bp); unco=length(ap)-rank(Co)
Ob=obsv(ap,cp1); unob = length(ap)-rank(Ob)

% Internal model
AR=0; BR=1;

% A_bar, B_bar, C_bar
A=[AR -BR*cp1; zeros(na,1) ap];
B=[0; bp]; Bi=[BR; zeros(na,1)];
C=[0 cp1];

% Feedback gain
RF=1; QF=diag([1 10 10 1 1]);
F=lqr(A,B,QF,RF); FR=F(1,1); Fp=F(1,2:na+1);

% Internal model + state feedback
sys=ss(A-B*F,Bi,C,0); sysu=ss(A-B*F,Bi,-F,0);
figure(1), hold on;
step(sys); grid;
figure(2), hold on;
step(sysu); grid;

% Observer gain
po=[-10+2i -10-2i -20+5i -20-5i];
L=(place(ap',cp1',po))'; eig(ap-L*cp1)

% A_tilde, B_tilde, C_tilde
At=[AR -BR*cp1 zeros(1,na); zeros(na,1) ap zeros(na,na); zeros(na,1) L*cp1 ap-L*cp1];
Bt=[0; bp; bp];
Bit=[BR; zeros(2*na,1)];
Ct=[0 cp1 zeros(1,na)];
Ft=[FR zeros(1,na), Fp];

% Internal model + state observer + state feedback
sysob=ss(At-Bt*Ft,Bit,Ct,0); sysobu=ss(At-Bt*Ft,Bit,-Ft,0);
figure(1), step(sysob)
figure(2), step(sysobu);